generic
	with function "<"(X,Y: in TElemento) return boolean is <>;
package Contenedores.Rojo_Negros is
	-- Tipo contenedor implementado con un rbol binario de bsqueda.
	type Rojo_Negro is new Contenedor with private;
		-- Los contenedores se crean vacos.

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Rojo_Negro; E: in TElemento);
		-- Aade el elemento E al contenedor C, si no est ya presente.
		-- Si E est en C no hace nada.
		-- Si cuando se va a realizar la insercin no hay espacio,
		-- se lanza la excepcin Contenedor_Lleno.

	procedure Extraer(C: in out Rojo_Negro; E: in TElemento);
		-- Se quita el elemento E del contendor C. Si E no est en C,
		-- no hace nada.

	procedure Vaciar(C: in out Rojo_Negro);
		-- Vaca el contenedor C, dejndolo sin elementos.

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in Rojo_Negro; E: in TElemento) return boolean;
		-- Devuelve True si el elemento E est en el contendor C
		-- y False si no.

	function Tamao(C: in Rojo_Negro) return Natural;
		-- Devuelve el nmero de elementos del contenedor C.

	-----------------------------------------
	-- PRUEBA; BORRAR -----------------------
	-----------------------------------------
	procedure Comprobar_Rojo_Negro(C: in Rojo_Negro);
	-----------------------------------------
	-- PRUEBA; BORRAR -----------------------
	-----------------------------------------
private
	type Nodo_Rojo_Negro;
	type Rbol_Rojo_Negro is access Nodo_Rojo_Negro;
	type Lista_Hijos is array(1..2) of Rbol_Rojo_Negro;

	type Nodo_Rojo_Negro is record
		Es_Rojo: Boolean;
		Clave  : TElemento;
		Hijos  : Lista_Hijos; --Hijos(1) = Hijo izqdo.
							  --Hijos(2) = Hijo drcho.
	end record;

	type Rojo_Negro is new Contenedor with record
		Elementos: rbol_Rojo_Negro;
	end record;
end Contenedores.Rojo_Negros;
