package rbolesBinariosBsqueda;

import contenedores.ContenedorOrdenado;
/**
 * @author marga
 *
 * Para cambiar la plantilla para este comentario de tipo generado vaya a
 * Ventana&gt;Preferencias&gt;Java&gt;Generacin de cdigo&gt;Cdigo y comentarios
 */
public class rbolRojoNegro
	extends rbolBinarioAjustable
	implements ContenedorOrdenado {
	private class NodoRojoNegro extends NodoBinario {
		boolean esRojo;
		/**
		 * 
		 */
		public NodoRojoNegro(Comparable info) {
			super(info);
			esRojo = true;
		}
	}

	private NodoRojoNegro raz;
	/**
	 * 
	 */
	public rbolRojoNegro() {
		super();
	}

	/* (non-Javadoc)
	 * @see contenedores.ContenedorOrdenado#extraer(java.lang.Comparable)
	 */
	 public boolean est(Comparable valor) {
		 return super.est(raz, valor);
	 }
	 
	public void extraer(Comparable valor) {
		BooleanoMutable propiedadCamino = new BooleanoMutable();
		raz = extraer(raz, valor, propiedadCamino);
		pruebaPropiedadRojo(raz);           //Borrarlo es una prueba
		pruebaPropiedadCamino(raz);         //Borrarlo es una prueba
	}

	private NodoRojoNegro extraer(
		NodoRojoNegro nodo,
		Comparable valor,
		BooleanoMutable propiedadCamino) {
		NodoRojoNegro hijo, hermano;
		int rama;
		if (nodo != null) {
			if (valor.compareTo(nodo.clave) == 0)
			/*Se ha encontrado el nodo a extraer
			 * tiene grado 0 o 1?
			 */
				if ((nodo.enlaces[0] == null) || (nodo.enlaces[1] == null)) {
					numElem--;
					if (nodo.enlaces[0] == null)
						rama = 1;
					else
						rama = 0;
					hijo = (NodoRojoNegro) nodo.enlaces[rama];
					propiedadCamino.ponerVerdadero();
					if (nodo.esRojo || nodo == raz)
					/*El nodo que se va a borrar es rojo o 
					 * es raz (con un solo hijo)
					 */
						propiedadCamino.ponerFalso();
					else if (hijo != null && hijo.esRojo) {
						//El nodo s- es rojo
						hijo.esRojo = false;
						propiedadCamino.ponerFalso();
					}
					return hijo;
				} else {
					/*Tiene grado 2, hay que extraer su sucesor
					 * en simtrico
					 */
					nodo.enlaces[1] =
						extraerSucesor(
							nodo,
							(NodoRojoNegro) nodo.enlaces[1],
							propiedadCamino);
					rama = 1;
				}
			else {
				/*Si valor es distinto de nodo.clave, la extraccin se producir 
				 * en el subrbol que corresponda
				 */
				if (valor.compareTo((Comparable) nodo.clave) < 0)
					rama = 0;
				else
					rama = 1;
				nodo.enlaces[rama] =
					extraer(
						(NodoRojoNegro) nodo.enlaces[rama],
						valor,
						propiedadCamino);
			}
			//No se cumple la propiedad del camino
			if (propiedadCamino.valorLgico()) {
				hermano = (NodoRojoNegro) nodo.enlaces[1 - rama];
				if (!(hermano.esRojo) && hijosNegros(hermano)) {
					/*Caso 2 del texto (Se produce tambin dentro de
					 * Extraer_Sucesor)
					 */
					hermano.esRojo = true;
					if (nodo.esRojo) {
						//No se propaga la recoloracin
						nodo.esRojo = false;
						propiedadCamino.ponerFalso();
					}
				} else {
					nodo = restauraPropiedadCamino(nodo, rama);
					propiedadCamino.ponerFalso();
				}
			}
		}
		return nodo;
	}

	private NodoRojoNegro extraerSucesor(
		NodoRojoNegro nodoExtraer,
		NodoRojoNegro nodo,
		BooleanoMutable propiedadCamino) {
		NodoRojoNegro hijo, hermano;
		if (nodo.enlaces[0] == null) {
			//nodo es el sucesor
			nodoExtraer.clave = nodo.clave;
			numElem--;
			hijo = (NodoRojoNegro) nodo.enlaces[1];
			propiedadCamino.ponerVerdadero();
			if (nodo.esRojo)
			    //El nodo que se va a borrar es rojo
				propiedadCamino.ponerFalso();
			else if (hijo != null && hijo.esRojo) {
				//El nodo s- es rojo
				hijo.esRojo = false;
				propiedadCamino.ponerFalso();
			}
			nodo = hijo;
		} else {
			//El sucesor es descendiente de nodo
			nodo.enlaces[0] =
				extraerSucesor(
			nodoExtraer,
					(NodoRojoNegro) nodo.enlaces[0],
					propiedadCamino);
			if (propiedadCamino.valorLgico()) {
				hermano = (NodoRojoNegro) nodo.enlaces[1];
				if (!(hermano.esRojo) && hijosNegros(hermano)) {
					//Caso 2 del texto
					//(Se produce tambin en el cuerpo de extraer)
					hermano.esRojo = true;
					if (nodo.esRojo) {
						//No se propaga la recoloracin
						nodo.esRojo = false;
						propiedadCamino.ponerFalso();
					}
				} else {
					nodo = restauraPropiedadCamino(nodo, 0);
					propiedadCamino.ponerFalso();
				}
			}
		}
		return nodo;
	}

    //Indica si los dos hijos de nodo son negros
	private boolean hijosNegros(NodoRojoNegro nodo) {
		NodoRojoNegro hijo = (NodoRojoNegro) nodo.enlaces[0];
		NodoRojoNegro otroHijo = (NodoRojoNegro) nodo.enlaces[1];
		if ((hijo == null) && (otroHijo == null))
			return true;
		else if (
			((hijo != null) && (!(hijo.esRojo)))
				&& ((otroHijo != null) && (!(otroHijo.esRojo))))
			return true;
		else
			return false;
	}
	/* (non-Javadoc)
	 * @see contenedores.ContenedorOrdenado#insertar(java.lang.Comparable)
	 */
	public void insertar(Comparable valor) {
		BooleanoMutable propiedadRojo = new BooleanoMutable();
		raz = insertar(raz, valor, propiedadRojo);
		pruebaPropiedadRojo(raz);           //Borrarlo es una prueba
		pruebaPropiedadCamino(raz);         //Borrarlo es una prueba
	}

	private NodoRojoNegro insertar(
		NodoRojoNegro nodo,
		Comparable valor,
		BooleanoMutable propiedadRojo) {
		NodoRojoNegro padre, tio, hijo;
		int rama;
		if (nodo == null) {
			//El nuevo valor se inserta como hoja
			nodo = new NodoRojoNegro(valor);
			numElem++;
			propiedadRojo.ponerVerdadero();
		} else {
			//Si valor es igual a nodo.clave no se inserta
			if (valor.compareTo(nodo.clave) != 0) {
				//La insercin continua en el subrbol adecuado
				if (valor.compareTo(nodo.clave) < 0) {
					rama = 0;
				} else {
					rama = 1;
				}
				nodo.enlaces[rama] =
					insertar(
						(NodoRojoNegro) nodo.enlaces[rama],
						valor,
						propiedadRojo);
				if (propiedadRojo.valorLgico()) {
					if (nodo.esRojo)
						{
							/*Hay que ascender otro nivel, a menos
							 *que se est en la raz 
							 */	
						if (nodo == raz)
							{
							//Slo se cambia el color si es la raz
							nodo.esRojo = false;
							propiedadRojo.ponerFalso();
						}
					} else {
						//nodo es de color negro
						padre = (NodoRojoNegro) nodo.enlaces[rama];
						//Se ha resuelto el conflicto rojo-rojo?
						if (hijosNegros(padre))
							propiedadRojo.ponerFalso();
						else {
							tio = (NodoRojoNegro) nodo.enlaces[1 - rama];
							/*El color del to determina si se elige
							 * una recoloracin o una rotacin
							 */              
							if ((tio != null) && (tio.esRojo))
								recoloracin(nodo);
							else {
								/*La relacin abuelo, padre e hijo es
								 * izquierda-izquierda o derecha-derecha
								 */
								hijo = (NodoRojoNegro) padre.enlaces[rama];
								//Est ah el conflicto rojo-rojo?
								if (hijo != null
									&& hijo.esRojo
									&& padre.esRojo)
									nodo = rotacinSimple(nodo, rama);
								else
									nodo = rotacinDoble(nodo, rama);
								//Se han restablecido las propiedades del rbol Rojo-Negro  
								propiedadRojo.ponerFalso();
							}
						}
					}
				}
			}
		}
		return nodo;
	}
	
    //Pone el color de un nodo a rojo y el de sus hijos a negro
	private void recoloracin(NodoRojoNegro nodo) {
		NodoRojoNegro hijo = (NodoRojoNegro) nodo.enlaces[0];
		NodoRojoNegro otroHijo = (NodoRojoNegro) nodo.enlaces[1];
		nodo.esRojo = true;
		hijo.esRojo = false;
		otroHijo.esRojo = false;
	}

	private NodoRojoNegro restauraPropiedadCamino(
		NodoRojoNegro nodo,
		int rama) {
		NodoRojoNegro hermano, hijo, hijoHerAlejadoS, hijoHerProximoS;
		hermano = (NodoRojoNegro) nodo.enlaces[1 - rama];
		if (hermano.esRojo) {
			//Caso 1 del texto
			nodo = rotacinSimple(nodo, 1 - rama);
			hermano = (NodoRojoNegro) nodo.enlaces[rama].enlaces[1 - rama];
			if (!(hermano.esRojo) && hijosNegros(hermano)) {
				//Caso 2 del texto
				hermano.esRojo = true;
				hijo = (NodoRojoNegro) nodo.enlaces[rama];
				hijo.esRojo = false;
				//Se han restablecido las propiedades del rbol Rojo-Negro
			} else
				nodo.enlaces[rama] =
					restauraPropiedadCamino(
						(NodoRojoNegro) nodo.enlaces[rama],
						rama);
		} else {
			hijoHerAlejadoS = (NodoRojoNegro) hermano.enlaces[1 - rama];
			hijoHerProximoS = (NodoRojoNegro) hermano.enlaces[rama];
			if (hijoHerAlejadoS != null && hijoHerAlejadoS.esRojo) {
				//Caso 3 del texto
				nodo = rotacinSimple(nodo, 1 - rama);
				hijoHerAlejadoS.esRojo = false;
				//Se han restablecido las propiedades del rbol Rojo-Negro
			} else if (
				(hijoHerAlejadoS == null || !(hijoHerAlejadoS.esRojo))
					&& hijoHerProximoS.esRojo) {
				//Caso 4 del texto
				nodo.enlaces[1 - rama] =(NodoRojoNegro)
					rotacinSimple((NodoRojoNegro)nodo.enlaces[1 - rama], rama);
				nodo = restauraPropiedadCamino(nodo, rama);
			}
		}
		return nodo;
	}

	private NodoRojoNegro rotacinDoble(NodoRojoNegro nodo, int rama) {
		nodo = (NodoRojoNegro) super.rotacinDoble(nodo, rama);
		NodoRojoNegro hijo = (NodoRojoNegro) nodo.enlaces[1-rama];
		//Se cambian los colores
		nodo.esRojo = false;
		hijo.esRojo = true;
		return nodo;
	}

	private NodoRojoNegro rotacinSimple(NodoRojoNegro nodo, int rama) {
		nodo = (NodoRojoNegro) super.rotacinSimple(nodo, rama);
		NodoRojoNegro hijo = (NodoRojoNegro) nodo.enlaces[1 - rama];
		//Se cambian los colores
		boolean auxColor = nodo.esRojo;
		nodo.esRojo = hijo.esRojo;
		hijo.esRojo = auxColor;
		return nodo;
	}
	
	public void vaciar() {
		raz = null;
		numElem = 0;
	}
    
	   public void pruebaPropiedadRojo(NodoRojoNegro nodo)   //BORRARLO es una prueba
	   {
		  if(nodo!=null)
		  {
			 pruebaPropiedadRojo((NodoRojoNegro)nodo.enlaces[0]);
			 NodoRojoNegro hijo=(NodoRojoNegro)nodo.enlaces[0], otroHijo=(NodoRojoNegro)nodo.enlaces[1];
			 if (nodo.esRojo && ((hijo!=null && hijo.esRojo)||(otroHijo!=null && otroHijo.esRojo)))
			System.out.println( "No se cumple la propiedad del rojo");
			 pruebaPropiedadRojo((NodoRojoNegro)nodo.enlaces[1]);
		  }
	   }
   
	   public int pruebaPropiedadCamino(NodoRojoNegro nodo)   //BORRARLO es una prueba
 	   {
		  if(nodo==null)
			 return 0;
		  else
		  {
			 int hnegraizq, hnegrader;
			 hnegraizq=pruebaPropiedadCamino((NodoRojoNegro)nodo.enlaces[0]);
			 hnegrader=pruebaPropiedadCamino((NodoRojoNegro)nodo.enlaces[1]);
			 if (hnegraizq!=hnegrader)
			System.out.println( "No se cumple la propiedad del camino");
			 if(!nodo.esRojo)
				return hnegraizq+1;
			 else
				return hnegraizq;
		  }
	   }
}